/*
**	mtest1.c
**
**      A simple test program for Motif.
**	Copyright (c) 1991 Sebern Engineering Inc.
*/

#include <stdio.h>
#include <stdlib.h>
#include <Mrm/MrmAppl.h>

/*  Data needed to access the UIL interface declaration. */
static MrmHierarchy	s_MrmHierarchy;
static char		*uid_file_names [] = {"mtest1.uid"};
static MrmCount		uid_file_num = XtNumber (uid_file_names);

static MrmType		widget_class;
static XtAppContext	mtest1_app_context;
static Widget		wid_top_level;
static Widget		wid_mtest1_main = (Widget) NULL;

/*  Callback routine declaration. */
static void mtest1_cb_exit (Widget w,
			    int *tag,
			    XmAnyCallbackStruct *callback_data);
static MrmRegisterArg	reg_vec [] =
			{{"mtest1_cb_exit",(caddr_t) mtest1_cb_exit}};
static MrmCount		reg_num = XtNumber (reg_vec);

main (int argc, char *argv[])
{
    Cardinal	mrm_status;

    /*	Initialize the Motif Resource Manager and create the
	main application shell widget. */
    MrmInitialize ();
    wid_top_level = XtAppInitialize (&mtest1_app_context,
				     "Mtest1",
				     (XrmOptionDescList) NULL,
				     0,
    /* For X11R4, "(Cardinal *) &argc" may be required. */
				     &argc,
				     (String *) argv,
				     (String *) NULL,
				     (ArgList) NULL,
				     0);

    /*	Access the compiled UIL interface declaration. */
    mrm_status = MrmOpenHierarchy (uid_file_num,
				   uid_file_names,
				   (MrmOsOpenParamPtr *) NULL,
				   &s_MrmHierarchy);
    if (mrm_status != MrmSUCCESS)
    {
    	printf ("Can't open hierarchy.\n");
	exit (0);
    }

    /*	Register the callback routine. */
    mrm_status = MrmRegisterNames (reg_vec,reg_num);
    if (mrm_status != MrmSUCCESS)
    {
    	printf ("Can't register callback routine.\n");
	exit (0);
    }

    /*	Create the rest of the user interface from the UIL
	declaration. */
    mrm_status = MrmFetchWidget (s_MrmHierarchy,
				 "mtest1_main",
				 wid_top_level,
				 &wid_mtest1_main,
				 &widget_class);
    if (mrm_status != MrmSUCCESS)
    {
    	printf ("Can't fetch main widget.\n");
	exit (0);
    }

    /*	Bring up the main application window. */
    XtManageChild (wid_mtest1_main);
    XtRealizeWidget (wid_top_level);

    /*	Let the toolkit handle user interactions. Our callback routine
	will be invoked when the user activates the push button. */
    XtAppMainLoop (mtest1_app_context);

    /* Should not be able to reach this return. */
    return (0);
}

/*  Callback routine invoked when the push button is activated.
    Exit from the program. */
static void mtest1_cb_exit (Widget w,
			    int *tag,
			    XmAnyCallbackStruct *callback_data)
{
    exit (0);
}
